const
  cpackset: array[1..4] of byte = (1,2,4,8);
  maxlow=32;
  maxhigh=64;

function nset(setnr,psi: longint): longint;
begin
  nset:=setnr+psi*(succ(maxlow)*succ(maxhigh));
end;

var
  t: text;
  psi, lowset, highset, setnr: longint;
begin
  assign(t,'testsetdata.pp');
  rewrite(t);

  writeln(t,'uses setconv;');
  writeln(t,'var f: file;');
  writeln(t,'var buf: array[0..31] of byte;');
  writeln(t);
  writeln(t,'{$i+}');
  writeln(t);
  psi:=0;
  setnr:=0;
  while (psi<=high(cpackset)) do
    begin
      for lowset:=0 to maxlow do
        for highset:=lowset to maxhigh do
          begin
            writeln(t,'type');
            writeln(t,'  ts',nset(setnr,psi),'= set of ',lowset,'..',highset,';');
            writeln(t,'var');
            writeln(t,'  sa',nset(setnr,psi),', sb',nset(setnr,psi),': ts',nset(setnr,psi),';');
            inc(setnr);
          end;
      writeln(t);
      inc(psi);
      if (psi<=high(cpackset)) then
        writeln(t,'{$packset ',cpackset[psi],'}');
    end;
    writeln(t);

    setnr:=0;
    psi:=0;
    while (psi<=high(cpackset)) do
      begin
        for lowset:=0 to maxlow do
         begin
          writeln(t,'procedure testps',psi*(maxlow+1),'_',lowset,';');
          writeln(t,'var');
          writeln(t,'  i: longint;');
          writeln(t,'begin');
          for highset:=lowset to maxhigh do
            begin
              writeln(t,'  for i:=',lowset,' to ',highset,' do');
              writeln(t,'    include(sa',nset(setnr,psi),',',lowset,'+random(',highset-lowset+1,'));');
              writeln(t,'  blockread(f,buf,fpc_oldsetsize(',highset,'));');
              writeln(t,'  if not fpc_convertset(buf,sb',nset(setnr,psi),',',lowset,',',highset,',',cpackset[psi],') or');
              writeln(t,'     (sa',nset(setnr,psi),'<>sb',nset(setnr,psi),') then');
              writeln(t,'    begin');
              writeln(t,'      writeln(''error for set ',lowset,'..',highset,' with psi = ',psi,''');');
              writeln(t,'    end;');
              inc(setnr);
            end;
          writeln(t,'end;');
          writeln(t);
         end;
        writeln(t,'procedure testps',psi,';');
        writeln(t,'begin');
        for lowset:=0 to maxlow do
          writeln(t,'  testps',psi*(maxlow+1),'_',lowset,';');
        writeln(t,'end;');
        writeln(t);
        writeln(t);
        writeln(t);
        writeln(t);
        inc(psi);
      end;
    writeln(t,'begin');
    writeln(t,'  randseed:=1;');
    writeln(t,'  assign(f,''setdata.dat'');');
    writeln(t,'  reset(f,1);');
    for psi:=0 to high(cpackset) do
      writeln(t,'  testps',psi,';');
    writeln(t,'  close(f);');
    writeln(t,'end.');
    close(t);
end.
